#include "BitmapIO.h"
#include "bmpcorr.h"
#include <stdlib.h>

#ifndef IMAGEIO_H_
#define IMAGEIO_H_

#  ifdef __cplusplus
extern "C" {
#  endif /* __cplusplus */



int writeBmp(char* filename, int width, int height, unsigned char* bits)
{
	GLubyte* padded = NULL;

	BITMAPINFO* info = (BITMAPINFO*)malloc(sizeof(BITMAPINFO));

	ZeroMemory(&(info->bmiHeader), sizeof(BITMAPINFOHEADER));
	info->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	info->bmiHeader.biWidth = width;
	info->bmiHeader.biHeight = height;
	info->bmiHeader.biPlanes = 1;
	info->bmiHeader.biBitCount = 24;
	info->bmiHeader.biCompression = 0;
	info->bmiHeader.biSizeImage = 3*width*height;

	bmppad((void**)&padded, bits, info);

	SaveDIBitmap(filename, info, padded);

	delete[] padded;
	delete info;

	return 0;
}

int loadBmp(char* filename, int* width, int* height, GLubyte** bits)
{
	GLubyte* padded = NULL;
	BITMAPINFO* info;

	*bits = NULL;

	padded = LoadDIBitmap(filename, &info);

	if(info->bmiHeader.biBitCount == 24) {
		bmpunpad((void**)bits, padded, info);
	} else {
		bmpunindex((void**)bits, padded, info);
	}

	*width = info->bmiHeader.biWidth;
	*height = info->bmiHeader.biHeight;

	delete[] padded;
	delete info;

	return 0;
}


#  ifdef __cplusplus
}
#  endif /* __cplusplus */


#endif /* IMAGEIO_H_ */
